OBJ 
  debug: "MultiCogSerialDebug"  'debugport serial driver
  hp1: "heap"
  que: "insque"
  
CON
    _clkmode = xtal1 + pll16x      '80MHz operating frequency.
    _xinfreq = 5_000_000

  ' struct dataBlock
  '   queHeader_t queHeader
  '   word        firstField
  '   word        secondField
  '   long        thirdField
  
  FIRST_FIELD_OFFSET = que#q_data
  SECOND_FIELD_OFFSET = que#q_data + 2
  THIRD_FIELD_OFFSET  = SECOND_FIELD_OFFSET + 2
  DATA_BLOCK_SIZE = que#q_data + 8

   CR = 13

   serXmit   = 30                      ' Serial Transmit
   serRecv   = 31                      ' Serial Receive
   speed     = 9600

   HEAP_SIZE = 512
VAR
  word queHead[2]
  byte heapArray[HEAP_SIZE]           'heapArray will be used to hold a heap
  
DAT
    debugSemID byte 0
    queSemID byte 0
      
PUB main | tstPtr, delPtr
  debugSemID := locknew
  queSemID := locknew
  
  debug.start(serRecv,serXmit,0,speed,debugSemID)

  que.initQueHead(@queHead)
  
  debug.cprintf(string("start of main program\r"), 0, false)
  debug.cprintf(string("queue head forward %x\r"), queHead[0], false) 
  debug.cprintf(string("queue head backward %x\r"), queHead[1], false) 

  hp1.create(@heapArray, HEAP_SIZE)

  if (hp1.available => DATA_BLOCK_SIZE)
    tstPtr := hp1.allocate(DATA_BLOCK_SIZE)
    delPtr := tstPtr
    debug.cprintf(string("tstNode1 address %x\r"), tstPtr, false)
    WORD[tstPtr+FIRST_FIELD_OFFSET] := 1
    WORD[tstPtr+SECOND_FIELD_OFFSET] := $12
    LONG[tstPtr+THIRD_FIELD_OFFSET] := $1234
    que.insqueTail(tstPtr, @queHead, queSemID)

  if (hp1.available => DATA_BLOCK_SIZE)
    tstPtr := hp1.allocate(DATA_BLOCK_SIZE)
'    delPtr := tstPtr
    debug.cprintf(string("tstNode2 address %x\r"), tstPtr, false) 
    WORD[tstPtr+FIRST_FIELD_OFFSET] := 2
    que.insqueTail(tstPtr, @queHead, queSemID)

  if (hp1.available => DATA_BLOCK_SIZE)
    tstPtr := hp1.allocate(DATA_BLOCK_SIZE)
'    delPtr := tstPtr
    debug.cprintf(string("tstNode3 address %x\r"), tstPtr, false) 
    WORD[tstPtr+FIRST_FIELD_OFFSET] := 3
    que.insqueTail(tstPtr, @queHead, queSemID)


  debug.cprintf(string("after insque\r"), 0, false) 

  debug.cprintf(string("queue head forward %x\r"), queHead[0], false) 
  debug.cprintf(string("queue head backward %x\r"), queHead[1], false) 

  debug.cprintf(string("forwards through queue\r"), 0, false)
  tstPtr := que.getFirst(@queHead, queSemID)

  repeat while tstPtr <> 0
    debug.cprintf(string("tstPtr %x "), tstPtr, true)
    debug.cprintf(string("f1: %x "),  WORD[tstPtr+FIRST_FIELD_OFFSET], true)
    debug.cprintf(string("f2: %x "),  WORD[tstPtr+SECOND_FIELD_OFFSET], true)
    debug.cprintf(string("f3: %x\r"), LONG[tstPtr+THIRD_FIELD_OFFSET], false)
    tstPtr := que.getNext(@queHead, tstPtr, queSemID)

  que.remque(delPtr, queSemID)
  hp1.free(delPtr)
  debug.cprintf(string("forwards through queue after deleting %x\r"), delPtr, false)
  tstPtr := que.getFirst(@queHead, queSemID)

  repeat while tstPtr <> 0
    debug.cprintf(string("tstPtr %x "), tstPtr, true)
    debug.cprintf(string("f1: %x "),  WORD[tstPtr+FIRST_FIELD_OFFSET], true)
    debug.cprintf(string("f2: %x "),  WORD[tstPtr+SECOND_FIELD_OFFSET], true)
    debug.cprintf(string("f3: %x\r"), LONG[tstPtr+THIRD_FIELD_OFFSET], false)
    tstPtr := que.getNext(@queHead, tstPtr, queSemID)

  debug.cprintf(string("end of main program\r"), 0, false) 

  
